<script setup>
import AppLayout from '@/Layouts/AppLayoutWater.vue';
import Welcome from '@/Jetstream/Welcome.vue';
import mapboxgl from 'mapbox-gl';
import 'mapbox-gl/dist/mapbox-gl.css';
import Highcharts from 'highcharts';
import VuePapaParse from 'vue-papa-parse'
import * as turf from '@turf/turf'
</script>
<style>
*,
::before,
::after {
    --tw-ring-color: rgb(59 130 246 / 0) !important;
}

    /* #menu {
        background: rgb(44, 91, 136);
        position: absolute;
        z-index: 1000;
        top: 3.7rem;
        right: 1rem;
        border-radius: 8px;
        width: 120px;
        border: 1px solid #fff;
    }

    #menu a {
        font-size: 13px;
        color: #05fff3;
        display: block !important;
        margin: 0;
        padding: 0;
        padding: 10px;
        text-decoration: none;
        border-bottom: 1px solid #fff;
        text-align: center;
    }

    #menu a:last-child {
        border: none;
    }

    #menu a:hover {
        background-color: rgb(3, 63, 119);
        color: #05fff3;
    }

    #menu a.active {
        background-color: rgba(0, 42, 80);
        color: #05fff3;
    }

    #menu a.active:hover {
        background: rgb(3, 63, 119);
    } */

    .map-overlay {
        position: absolute;
        width: 30px;
        top: 4.5rem;
        left: 1rem;
        padding: 0px;

    }

    .map-overlay .map-overlay-inner {
        background-color: rgba(0, 42, 80, 0);
        /*box-shadow: 0 1px 2px rgba(0, 0, 0, 0.2);*/
        border-radius: 8px;
        padding: 0px;
        margin-bottom: 10px;
        height: 60vh;
    }

    [id*=flat-slider].ui-slider.ui-slider-vertical {
        width: 6px;
        height: 85vh;
        display: inline-block;
        margin: 0 15%;
    }

    .ui-slider-vertical.ui-slider-pips .ui-slider-label {
        top: 50%;
        left: 2em;
        color: #fff;
    }

    [id*=flat-slider].ui-slider .ui-slider-handle {
        display: none !important;
    }

    .ui-slider-pips:not(.ui-slider-disabled) .ui-slider-pip:hover .ui-slider-label {
        color: #05fff3;
        font-weight: 700;
    }

    #flat-slider-vertical-3 .ui-slider-handle,
    #flat-slider-vertical-3 .ui-slider-range,
    #flat-slider-vertical-3 .ui-slider-pip[class*=ui-slider-pip-selected] .ui-slider-line,
    #flat-slider-vertical-3 .ui-slider-pip.ui-slider-pip-inrange .ui-slider-line {
        background-color: #05fff3;
    }

    [id*=flat-slider].ui-slider.ui-slider-vertical .ui-slider-pip[class*=ui-slider-pip-selected] .ui-slider-line {
        width: 25px;
    }

    [id*=flat-slider].ui-slider {
        background: transparent;
    }

    .bg-gray-200 {
        background-color: rgba(225, 225, 225, 0.9);
    }

    .peer:checked~.peer-checked\:bg-purple-600 {
        background-color: #05fff3;
    }

    @keyframes flow-right {
        from {
            transform: translateX(0);
        }

        to {
            transform: translateX(100%);
        }
    }

    /* .pipe {
        animation-name: flow-right;
        animation-duration: 5s;
        animation-timing-function: linear;
        animation-iteration-count: infinite;
    } */

</style>
<template>
    <AppLayout title="WaterNetwork">
        <!-- START RIGHT SIDEMENU -->
        <div id="sidemenu" style="height: calc(100vh - 2rem) !important;"
            class="cursor-default bg-transparent content-start min-h-fit grid grid-cols-2 box-border duration-300 overflow-y-scroll z-50 mb-0 right-0 top-13 w-0 fixed float-left">

            <!-- PRESSURE CHART -->
            <div id="chart1_box"
                class="shadow-lg bg-darkblue-opa-container rounded-lg col-span-2 w-full h-fit mb-3 duration-300">
                <p id="chart1_text" class="text-xs text-center text-cyan-text font-normal my-1">Pressure</p>
                <div id="chart1" class="w-[17.5rem] h-32 float-left cursor-crosshair"></div>
            </div>

            <!-- PRESSURE VARIATION CHART -->
            <div id="chart2_box"
                class="shadow-lg bg-darkblue-opa-container rounded-lg col-span-2 w-full h-fit mb-3 duration-300">
                <p id="chart2_text" class="text-xs text-center text-cyan-text font-normal my-1">Demand</p>
                <div id="chart2" class="w-[17.5rem] h-32 float-left cursor-crosshair"></div>
            </div>

            <!-- FLOW CHART -->
            <div id="chart3_box"
                class="shadow-lg bg-darkblue-opa-container rounded-lg col-span-2 w-full h-fit mb-3 duration-300">
                <p id="chart3_text" class="text-xs text-center text-cyan-text font-normal my-1">Head</p>
                <div id="chart3" class="w-[17.5rem] h-32 float-left cursor-crosshair"></div>
            </div>

        </div>
        <!-- END RIGHT SIDEMENU -->

        <!-- SEARCH BAR -->
        
        <!-- <div class="baltoro-container-2 overflow-x-hidden w-48 h-fit text-white-snow box-border z-50 ml-4 mt-16 left-0 top-0 fixed"
            id="screendevices">
            <input type="text" v-on:keyup="searchfilter()" :placeholder="$t('general.Search')"
                class="focus-visible:outline-0 bg-cyan-opa text-md text-center text-white-snow font-normal w-48" id="searchbar" />
            <ul class="text-xs text-center text-white-snow max-h-48 h-fit overflow-y-scroll" id="device_list"></ul>
        </div> -->
        <div id="legendSimulation"
            class="baltoro-container-2 w-fit h-fit box-border z-50 ml-4 mb-11 left-0 bottom-0 fixed flex flex-col py-1 px-2 text-gray-light text-base">
        </div>

        <!-- CONTENT FROM MAP -->
        <div id="content" class="p-0">
            <!-- MAPBOX MAP -->
            <!-- <nav id="menu"
                class="baltoro-container-2 w-fit h-fit box-border z-50 ml-4 mb-11 left-0 bottom-0 fixed flex flex-col py-1 px-2 text-gray-light text-sm">
            </nav> -->

            <div style="height: calc(100vh - 4.75rem);" id="map" />
            <div class="map-overlay">
                <div class="map-overlay-inner">
                    <div class="stuff">
                        <main>
                            <div id="flat-slider-vertical-3"></div>
                        </main>
                    </div>
                </div>
            </div>
        </div>
    </AppLayout>
</template>

<script>


    export default {

        data() {
            return {
                centralChart: {},
                geojsonJunctions: {},
                geojsonTanks: {},
                geojsonReservoirs: {},
                geojsonPipes: {},
                geojsonValves: {},
                newFeature: {},
                geojson: {},
                generalGeoJson: {},
                hasStartedMapActivities: false,
            };
        },

        props: ['idgroup', 'location', 'data', 'user'],

        beforecreated() {
            
        },

        mounted() {

            window.emitter.emit('changeLoaderStatus', false, 'orbit')

            //window.emitter.emit('changeLoaderStatus', true, 'orbit') //Start loadder

            /**
             * Vars declarations
             */

            window.time = 0

            this.geojsonJunctions = {
                'type': 'FeatureCollection',
                'features': []
            }

            this.geojsonTanks = {
                'type': 'FeatureCollection',
                'features': []
            }

            this.geojsonReservoirs = {
                'type': 'FeatureCollection',
                'features': []
            }


            this.geojsonPipes = {
                'type': 'FeatureCollection',
                'features': []
            }

            this.geojsonValves = {
                'type': 'FeatureCollection',
                'features': []
            }

            this.geojson = {
                "type": "FeatureCollection",
                "features": []
            };

            this.generalGeoJson = {
                "type": "FeatureCollection",
                "features": []
            };

            this.newFeature = {};


            mapboxgl.accessToken = 'pk.eyJ1IjoiZGF0YWtvcnVtLWRldmVsb3AiLCJhIjoiY2w0ODhqOXc2MDR1MjNjbzJ2YnZkdjNhYSJ9.pVPMnmkwOuF4DonlbNkkEw';

            if(this.idgroup == '556'){
                var zoom = 18;
            }else if(this.idgroup == '557'){
                var zoom = 12;
            }else{
                var zoom = 20;
            }

            const center = this.idgroup === '393' ? ['-0.51375641880504450000','38.96933983970090000000'] : [this.location.GPS_lng, this.location.GPS_lat];

            const map = new mapboxgl.Map({
                attributionControl: false,
                container: "map",
                style: 'mapbox://styles/datakorum-develop/cl4cu370w000v15tal53sxn9v',
                center: center,
                zoom: zoom,
                maxZoom: this.idgroupp === '393' ? 18 : 22,
                minZoom: 7,
                pitch: 0,
                maxPitch: 50,
                bearing: 0,

                // container: 'map',
                // // Choose from Mapbox's core styles, or make your own style with Mapbox Studio
                // style: 'mapbox://styles/mapbox/streets-v12',
                // center: [0, 0],
                // zoom: 0.5,
                // projection: 'equalEarth'
            });

            this.createGeoJsons();

            map.on('load', () => {
                const popup = new mapboxgl.Popup({
                    closeButton: false,
                    closeOnClick: false
                });
                const popupDetail = new mapboxgl.Popup({
                    closeButton: false,
                    closeOnClick: false
                });

                function closePopup(){
                    map.getCanvas().style.cursor = '';
                    popup.remove();
                }
                function closePopupDetail(){
                    map.getCanvas().style.cursor = '';
                    popupDetail.remove();
                }

                map.loadImage('assets/images/markers/reservoir.png', (error, image) => {
                    if (error) throw error;
                    map.addImage('reservoir', image);
                });

                //////////////START VALVES///////////////////
                map.addSource('valves', {
                    'type': 'geojson',
                    'data': this.geojsonValves
                });

                map.addLayer({
                    'id': 'valves',
                    'type': 'line',
                    'source': 'valves',
                    'layout': {
                        'line-join': 'round',
                        'line-cap': 'round',
                        'visibility': 'visible'
                    },
                    'paint': {
                        'line-color': '#FF07D6',
                        'line-width': 3,
                    }
                });

                map.on('mouseenter', 'valves', (e) => {
                    map.getCanvas().style.cursor = 'pointer';
                    //const coordinates = e.features[0].geometry.coordinates.slice();
                    const description = e.features[0].properties.description;

                    popup.setLngLat(e.lngLat).setHTML(description).addTo(map);
                });

                map.on('mouseleave', 'valves', () => { closePopup() });

                map.on('click', 'valves', (e) => {
                    const coordinates = e.features[0].geometry.coordinates.slice();
                    //const detail = e.features[0].properties.detail;
                    const options = e.features[0].properties.options;

                    while (Math.abs(e.lngLat.lng - coordinates[0]) > 180) {
                        coordinates[0] += e.lngLat.lng > coordinates[0] ? 360 : -360;
                    }
                    popupDetail.setLngLat(e.lngLat).setHTML(options).addTo(map);;
                    var checkbox = document.querySelector("input[name=checkbox]");

                    var idvalve = e.features[0].properties.idvalve
                    var checked = e.features[0].properties.checked

                    // checkbox.addEventListener('change', ()=> {
                    //     var elementStatus="open"
                    //     if (checked.includes("checked")) {
                    //         elementStatus="Closed"
                    //     } else {
                    //         elementStatus="Open"
                    //     }

                    //     this.changeStatusNetworkElement(idvalve, elementStatus, 'valve', map).then(response => {
                    //         //idnode, status, element, junctions, pipes, valves, map
                    //     })
                    // });
                    setTimeout(closePopupDetail, 8000);
                });

                //////////////END VALVES///////////////////

                //////////////START PIPES///////////////////

                for (let i = 0; i < this.geojsonPipes.features.length; i++) {
                    const feature = {
                        "type": "Feature",
                        "geometry": {
                            "type": "LineString",
                            "coordinates": []
                        }
                    };

                    this.geojson.features.push(feature);
                }

                map.addSource('pipes-animation', {
                    'type': 'geojson',
                    'data': this.geojson
                });


                map.addSource('pipes', {
                    'type': 'geojson',
                    'data': this.geojsonPipes,
                });

                map.addLayer({
                    'id': 'pipes',
                    'type': 'line',
                    'source': 'pipes',
                    'layout': {
                        'line-join': 'round',
                        'line-cap': 'round',
                        'visibility': 'visible'
                    },
                    'paint': {
                        // 'line-color': [
                        //     'match',
                        //     ['get', 'velocity'],
                        //     0, '#ff0000',
                        //     //'#0074D9'
                        //     'c'
                        // ],
                        'line-color': '#0DD3FF',
                        'line-width': 3,
                        'line-opacity': 0.8,
                    }
                });

                map.addLayer({
                    'id': 'pipes-animation',
                    'type': 'line',
                    'source': 'pipes-animation',
                    'layout': {
                        'line-cap': 'round',
                        'line-join': 'round',
                        'visibility': 'visible'
                    },
                    'paint': {
                        'line-color': '#0DD3FF',
                        'line-width': 5
                    }
                });

                map.on('mouseenter', 'pipes', (e) => {
                    map.getCanvas().style.cursor = 'pointer';
                    //const coordinates = e.features[0].geometry.coordinates.slice();
                    const description = e.features[0].properties.description;
                    popup.setLngLat(e.lngLat).setHTML(description).addTo(map);

                });

                map.on('mouseleave', 'pipes', () => { closePopup() });

                map.on('click', 'pipes', (e) => {
                    const coordinates = e.features[0].geometry.coordinates.slice();
                    //const detail = e.features[0].properties.detail;
                    const options = e.features[0].properties.options;

                    while (Math.abs(e.lngLat.lng - coordinates[0]) > 180) {
                        coordinates[0] += e.lngLat.lng > coordinates[0] ? 360 : -360;
                    }
                    popupDetail.setLngLat(e.lngLat).setHTML(options).addTo(map);;
                    var checkbox = document.querySelector("input[name=checkbox]");
                    var idpipe = e.features[0].properties.idpipe
                    var checked = e.features[0].properties.checked

                    // checkbox.addEventListener('change',  ()=> {
                    //     var elementStatus="Open"

                    //     if (checked.includes("checked")) {
                    //         elementStatus="Closed"
                    //     } else {
                    //         elementStatus="Open"
                    //     } 

                    // //     //window.emitter.emit('changeLoaderStatus', true, 'orbit') //Start loadder
                    // //     //CAMBIAR 
                    //     //self.changeStatusNetworkElement()
                    //     this.changeStatusNetworkElement(idpipe, elementStatus, "pipe", map)
                    // });

                    setTimeout(closePopupDetail, 8000);
                });
                ////////////////END PIPES//////////////////

                //////////////START JUNCTIONS///////////////////
                map.addSource('junctions', {
                    'type': 'geojson',
                    'data': this.geojsonJunctions
                });

                map.addLayer({
                    'id': 'junctions',
                    'type': 'circle',
                    'source': 'junctions',
                    'layout': {
                        'visibility': 'visible'
                    },
                    'paint': {
                        'circle-radius': 6,
                        'circle-color': '#166EB2',
                        "circle-stroke-width": 1,
                        "circle-stroke-color": '#fff'
                    }
                });

                map.on('mouseenter', 'junctions', (e) => {
                    map.getCanvas().style.cursor = 'pointer';
                    const coordinates = e.features[0].geometry.coordinates.slice();
                    const description = e.features[0].properties.description;

                    while (Math.abs(e.lngLat.lng - coordinates[0]) > 180) {
                        coordinates[0] += e.lngLat.lng > coordinates[0] ? 360 : -360;
                    }
                    popup.setLngLat(coordinates).setHTML(description).addTo(map);
                });

                map.on('mouseleave', 'junctions', () => {closePopup()});

                map.on('click', 'junctions', (e) => {
                    const coordinates = e.features[0].geometry.coordinates.slice();
                    const detail = e.features[0].properties.detail;

                    while (Math.abs(e.lngLat.lng - coordinates[0]) > 180) {
                        coordinates[0] += e.lngLat.lng > coordinates[0] ? 360 : -360;
                    }
                    popupDetail.setLngLat(coordinates).setHTML(detail).addTo(map);
                    //showNodeGraphs(e)
                    setTimeout(closePopupDetail, 8000);
                });
                //////////////END JUNCTIONS///////////////////

                //////////////START TANKS///////////////////
                map.addSource('tanks', {
                    'type': 'geojson',
                    'data': this.geojsonTanks
                });
                map.addLayer({
                    'id': 'tanks',
                    'type': 'circle',
                    'source': 'tanks',
                    'layout': {
                        'visibility': 'visible'
                    },
                    'paint': {
                        'circle-radius': 6,
                        'circle-color': '#FFFB07',
                        "circle-stroke-width": 1,
                        "circle-stroke-color": '#fff'
                    }
                });

                // map.addLayer({
                //     'id': 'tanks-symbol',
                //     'type': 'symbol',
                //     'source': 'tanks',
                //     'layout': {
                //         'visibility': 'visible',
                //         'text-field': 'T', // Texto "T" dentro del círculo
                //         'text-font': ['Open Sans Regular'], // Fuente del texto (puedes cambiarla según tus preferencias)
                //         'text-size': 12, // Tamaño del texto
                //         'text-justify': 'center', // Centra el texto dentro del círculo
                //         'text-anchor': 'center', // Ancla el texto en el centro del círculo
                //         'text-ignore-placement': true, // Ignora la colocación automática del texto
                //         'text-allow-overlap': true // Permite que el texto se superponga a otros símbolos
                //     },
                //     'paint': {
                //         'text-color': '#fff' // Color del texto (en este caso, blanco)
                //     }
                // });

                map.on('mouseenter', 'tanks', (e) => {
                    map.getCanvas().style.cursor = 'pointer';
                    const coordinates = e.features[0].geometry.coordinates.slice();
                    const description = e.features[0].properties.description;

                    while (Math.abs(e.lngLat.lng - coordinates[0]) > 180) {
                        coordinates[0] += e.lngLat.lng > coordinates[0] ? 360 : -360;
                    }
                    popup.setLngLat(coordinates).setHTML(description).addTo(map);
                });

                map.on('mouseleave', 'tanks', () => {closePopup()});

                map.on('click', 'tanks', (e) => { 
                    const coordinates = e.features[0].geometry.coordinates.slice();
                    const detail = e.features[0].properties.detail;

                    while (Math.abs(e.lngLat.lng - coordinates[0]) > 180) {
                        coordinates[0] += e.lngLat.lng > coordinates[0] ? 360 : -360;
                    }
                    popupDetail.setLngLat(coordinates).setHTML(detail).addTo(map);
                    //showNodeGraphs(e)
                    setTimeout(closePopupDetail, 8000)
                });
                //////////////END TANKS///////////////////

                //////////////START RESERVOIRS///////////////////
                map.addSource('reservoirs', {
                    'type': 'geojson',
                    'data': this.geojsonReservoirs
                });

                map.addLayer({
                    'id': 'reservoirs',
                    'type': 'circle',
                    'source': 'reservoirs',
                    'layout': {
                        'visibility': 'visible'
                    },
                    'paint': {
                        'circle-radius': 6,
                        'circle-color': '#39E306',
                        "circle-stroke-width": 1,
                        "circle-stroke-color": '#fff'
                    }
                });

                // map.addLayer({
                //     'id': 'reservoirs-symbol',
                //     'type': 'symbol',
                //     'source': 'reservoirs',
                //     'layout': {
                //         'visibility': 'visible',
                //         'text-field': 'R', // Texto "T" dentro del círculo
                //         'text-font': ['Open Sans Regular'], // Fuente del texto (puedes cambiarla según tus preferencias)
                //         'text-size': 12, // Tamaño del texto
                //         'text-justify': 'center', // Centra el texto dentro del círculo
                //         'text-anchor': 'center', // Ancla el texto en el centro del círculo
                //         'text-ignore-placement': true, // Ignora la colocación automática del texto
                //         'text-allow-overlap': true // Permite que el texto se superponga a otros símbolos
                //     },
                //     'paint': {
                //         'text-color': '#fff' // Color del texto (en este caso, blanco)
                //     }
                // });

                // map.addLayer({
                //     'id': 'reservoirs-symbol',
                //     type: 'symbol',
                //     'source': 'reservoirs',
                //     'layout': {
                //         'icon-image': 'reservoir',
                //         'icon-anchor': 'center',
                //         //'icon-size': ['interpolate', ['linear'], ['zoom'], 1, 0.08, 10, 0.08, 15, 0.08]
                //         'icon-size': ['interpolate', ['exponential', 2], ['zoom'], 13, 0.02, 14, 0.03, 15, 0.04, 16, 0.05, 17, 0.06],
                //     },
                // });

                map.on('mouseenter', 'reservoirs', (e) => {
                    map.getCanvas().style.cursor = 'pointer';
                    const coordinates = e.features[0].geometry.coordinates.slice();
                    const description = e.features[0].properties.description;

                    while (Math.abs(e.lngLat.lng - coordinates[0]) > 180) {
                        coordinates[0] += e.lngLat.lng > coordinates[0] ? 360 : -360;
                    }
                    popup.setLngLat(coordinates).setHTML(description).addTo(map);
                });

                map.on('mouseleave', 'reservoirs', () => { closePopup() });

                map.on('click', 'reservoirs', (e) => {
                    const coordinates = e.features[0].geometry.coordinates.slice();
                    const detail = e.features[0].properties.detail;

                    while (Math.abs(e.lngLat.lng - coordinates[0]) > 180) {
                        coordinates[0] += e.lngLat.lng > coordinates[0] ? 360 : -360;
                    }
                    popupDetail.setLngLat(coordinates).setHTML(detail).addTo(map);
                    //showNodeGraphs(e)
                    setTimeout(closePopupDetail, 8000)
                });

                
                // };

                //////////////END RESERVOIRS///////////////////

                var bounds = new mapboxgl.LngLatBounds();
                this.MapFitBounds(500, map, bounds);
            });


            let animation = false;

                // After the last frame rendered before the map enters an "idle" state.
            map.on('idle', () => {

                if (!this.hasStartedMapActivities) {
                    this.startMapActivities(map);
                    this.hasStartedMapActivities = true;
                }
                // If these two layers were not added to the map, abort
                // if (!map.getLayer('junctions') || !map.getLayer('tanks') || !map.getLayer('reservoirs') || !map.getLayer('pipes') || !map.getLayer('valves') || !map.getLayer('pipes-animation')) { ///revisar porque falla esto
                //     // return;
                // }

                // Enumerate ids of the layers.
                
            });

            /**
             * Chart template
             */

            const centralChart = {
                chart: {
                    backgroundColor: 'transparent',
                    spacingTop: 15
                },
                accessibility: {
                    enabled: false
                },
                title: {
                    text: ''
                },
                xAxis: {
                    visible: true,
                    labels: {
                        style: {
                            color: 'rgba(200, 200, 200, 0.9)'
                        }
                    },
                },
                yAxis: {
                    title: {
                        text: ''
                    },
                    labels: {
                        style: {
                            color: 'rgba(200, 200, 200, 0.9)'
                        }
                    },
                    visible: true
                },
                exporting: {
                    enabled: false
                },
                credits: {
                    enabled: false
                },
                legend: {
                    enabled: false,
                },
                tooltip: {
                    shared: true,
                    split: false,
                    backgroundColor: '#075267',
                    borderRadius: 12,
                    borderWidth: 0,
                    padding: 6,
                    formatter: function () {
                        var s = '<b>' + '<p style="font-size:12px; line-height: 12px; color:#b8bec0">' + this.x + '</p>';
                        $.each(this.points, function () {
                            s += '<br/><p style="color:' + this.series.color + '">' + this.series.name + ': <p><p style="color:#b8bec0"">' + this.y.toFixed(6) +
                                ' ' + this.series.userOptions.tooltip.valueSuffix + '<p><br/>';
                        });


                        return s;
                    },
                },
            };


            function showNodeGraphs(e) {
                //window.emitter.emit('changeLoaderStatus', true, 'orbit') //Start loadder

                var idnode = e.features[0].properties.idnode
                var simulation

                simulationDay(idnode).then(response => {
                    simulation = JSON.parse(response)

                    simulation.time.forEach(function (value, index, array) {
                        simulation.time[index] = simulation.time[index] / 60
                    })

                    centralChart.xAxis.categories = simulation.time;
                    centralChart.series = [{
                        name: "Pressure",
                        type: 'areaspline',
                        data: simulation.pressure,
                        color: "#05fff3",
                        lineWidth: 0,
                        opacity: 0.825,
                        marker: {
                            enabled: false
                        },
                        tooltip: {
                            valueSuffix: 'm.c.a'
                        }
                    }
                    ];
                    Highcharts.chart('chart1', centralChart);

                    centralChart.series = [{
                        name: "Demand",
                        type: 'areaspline',
                        data: simulation.demand,
                        color: "#05fff3",
                        lineWidth: 0,
                        opacity: 0.825,
                        marker: {
                            enabled: false
                        },
                        tooltip: {
                            valueSuffix: 'm3'
                        }
                    }
                    ];
                    Highcharts.chart('chart2', centralChart);

                    centralChart.series = [{
                        name: "Head",
                        type: 'areaspline',
                        data: simulation.head,
                        color: "#05fff3",
                        lineWidth: 0,
                        opacity: 0.825,
                        marker: {
                            enabled: false
                        },
                        tooltip: {
                            valueSuffix: 'm'
                        }
                    }
                    ];
                    Highcharts.chart('chart3', centralChart);

                    document.getElementById("sidemenu").style.width = "20rem";
                    document.getElementById("sidemenu").style.padding = "0.75rem 0.75rem 0 0.75rem";
                    document.getElementById("menu").style.marginRight = "20rem";

                    window.emitter.emit('changeLoaderStatus', false, 'semipolar') //End loadder
                })
            }

            /**
             * Obtain full simulation of a node
             */

            function simulationDay(idnode) {

                return axios({
                    method: 'get',
                    url: window.location.origin + '/api/epanet/simulation_by_node/' + idnode,
                    headers: {
                        'Accept': 'application/json',
                        'Content-Type': 'application/json',
                        'Authorization': 'Bearer ' + this.user.token
                    },
                })
                    .then( (response) => {
                        return [response.data];
                    })
                    .catch( (error) => {
                        return ("Failed!", error);
                    });

            };

            function simulationTime(time) {

                return axios({
                    method: 'get',
                    url: window.location.origin + '/api/epanet/simulation_by_time/' + time,
                    headers: {
                        'Accept': 'application/json',
                        'Content-Type': 'application/json',
                        'Authorization': 'Bearer ' + this.user.token
                    },
                })
                    .then( (response) => {
                        return [response.data];
                    })
                    .catch( (error) => {
                        return ("Failed!", error);
                    });

            };



            $.extend( $.ui.slider.prototype.options, {
                animate: 300
            });

            //barra de las horas
            $("#flat-slider-vertical-3").slider({
                max: 96,
                min: 0,
                range: 1,
                value: 0,
                orientation: "vertical",
                slide: (e, ui) => {
                    //console.log(ui.value*900)
                    window.time = ui.value * 900
                    //Start loadder
                    window.Papa.parse('simulations/data_time.csv', {
                        download: true,
                        complete: function (results) {
                            var dataUpdated = results.data

                            window.junctions.forEach(function (value, index, array){

                                window.junctions[index][5] = dataUpdated[index][2] //demand
                                window.junctions[index][6] = dataUpdated[index][3] //head

                            })
                            updateLayers()
                            //window.emitter.emit('changeLoaderStatus', false, 'orbit') //Start loadder
                        }
                    })
                }
            });

            //MENÚ LATERAL CON LAS HORAS

            // $("#flat-slider-vertical-3")
            // .slider("pips", {
            //     first: "label",
            //     last: "label",
            //     rest: "label",
            //     //step: 15,
            //     labels: [
            //             '00:00','','','', '','','','','02:00','','','','','','','',
            //             '04:00','','','', '','','','','06:00','','','','','','','',
            //             '08:00','','','', '','','','','10:00','','','','','','','',
            //             '12:00','','','', '','','','','14:00','','','','','','','',
            //             '16:00','','','', '','','','','18:00','','','','','','','',
            //             '20:00','','','', '','','','','22:00','','','','','','',''
            //             ]
            // })

        },

        methods: {

            startMapActivities( map){
 
                this.animatePipes(map);
                this.setupLegend(map);

            },

            setupLegend(map){
                const toggleableLayerIds = [
                    {
                        position: 1,
                        id: 'junctions',
                        name: this.$t("water.Junctions"),
                        paintStyle:  map.getPaintProperty('junctions', 'circle-color'),
                        circleRadius: map.getPaintProperty('junctions', 'circle-radius'),
                        circleStrokeColor: map.getPaintProperty('junctions', 'circle-stroke-color'),
                    }, {
                        position: 2,
                        id: 'tanks',
                        name:  this.$t("water.Tanks"),
                        paintStyle:  map.getPaintProperty('tanks', 'circle-color'),
                        circleRadius: map.getPaintProperty('tanks', 'circle-radius'),
                        circleStrokeColor: map.getPaintProperty('tanks', 'circle-stroke-color'),
                        // textField : map.getLayoutProperty('tanks-symbol', 'text-field'),
                        // textSize : map.getLayoutProperty('tanks-symbol', 'text-size'),
                        // textColor : map.getPaintProperty('tanks-symbol', 'text-color'),
                    }, {
                        position: 3,
                        id: 'reservoirs',
                        name:  this.$t("water.Reservoirs"),
                        paintStyle:  map.getPaintProperty('reservoirs', 'circle-color'),
                        circleRadius: map.getPaintProperty('reservoirs', 'circle-radius'),
                        circleStrokeColor: map.getPaintProperty('reservoirs', 'circle-stroke-color'),
                        // textField : map.getLayoutProperty('reservoirs-symbol', 'text-field'),
                        // textSize : map.getLayoutProperty('reservoirs-symbol', 'text-size'),
                        // textColor : map.getPaintProperty('reservoirs-symbol', 'text-color'),
                    }, {
                        position: 4,
                        id: 'pipes',
                        name:  this.$t("water.Pipes"),
                        lineColor:  map.getPaintProperty('pipes', 'line-color'),
                        lineWidth : map.getPaintProperty('pipes', 'line-width'),
                        lineOpacity: map.getPaintProperty('pipes', 'line-opacity'),
                    }, {
                        position: 5,
                        id: 'valves',
                        name:  this.$t("water.Valves"),
                        lineColor:  map.getPaintProperty('valves', 'line-color'),
                        lineWidth : map.getPaintProperty('valves', 'line-width'),
                        lineOpacity: 1,
                    }]

                // Set up the corresponding toggle button for each layer.
                for (const layerData of toggleableLayerIds) {
                    // Skip layers that already have a button set up.
                    if (document.getElementById(layerData.id)) {
                        continue;
                    }

                    // Create a link.
                    const link = document.createElement('a');
                    link.id = layerData.id;
                    link.href = '#';
                    //link.textContent = layerData.name;

                    if( layerData.position === 1 || layerData.position === 2 || layerData.position === 3){
                        
                        link.innerHTML = `<span class="h-4" style="background-color: ${layerData.paintStyle}; width:10px; height:10px; border-radius: 50%; border: 1px solid ${layerData.circleStrokeColor};"></span> <a>${layerData.name}</a>`;
                    }else{

                        link.innerHTML = `<hr style="border: none; border-top: ${layerData.lineWidth}px solid ${layerData.lineColor}; width: 20px; opacity: ${layerData.lineOpacity};"/> <a>${layerData.name}</a>`;
                    }

                    link.className = 'active inline-flex gap-1 justify-start items-center';
                    if (layerData.position == 1){
                        link.setAttribute('style', 'border-radius: 8px 8px 0px 0px;',);
                    }
                    if (layerData.position == 5){
                        link.setAttribute('style', 'border-radius: 0px 0px 8px 8px;',);
                    }


                    // Show or hide layer when the toggle is clicked.
                    link.onclick = function (e) {
                        const clickedLayer = this.id;
                        e.preventDefault();
                        e.stopPropagation();

                        const visibility = map.getLayoutProperty(
                            clickedLayer,
                            'visibility'
                        );

                        // Toggle layer visibility by changing the layout object's visibility property.
                        if (visibility === 'visible') {
                            map.setLayoutProperty(clickedLayer, 'visibility', 'none');
                            this.className = "inline-flex gap-1 justify-start items-center text-gray-medium";
                        } else {
                            this.className = 'active inline-flex gap-1 justify-start items-center';
                            map.setLayoutProperty(
                                clickedLayer,
                                'visibility',
                                'visible'
                            );
                        }

                        if (clickedLayer === 'pipes') {

                            const visibility = map.getLayoutProperty(
                                'pipes-animation',
                                'visibility'
                            );

                            if (visibility === 'visible') {
                                map.setLayoutProperty('pipes-animation', 'visibility', 'none');

                            } else {
                                map.setLayoutProperty('pipes-animation', 'visibility', 'visible');
                            }

                        }

                    };

                    const layers = document.getElementById('legendSimulation');
                    layers.appendChild(link);
                    layers.classList.remove('hidden');
                }
            },

            createGeoJsons(){
                var description;
                //var junctions = window.junctions
                var nodes_coords = {}

                this.geojsonJunctions['features'].splice(0, this.geojsonJunctions['features'].length);
                this.geojsonTanks['features'].splice(0, this.geojsonTanks['features'].length);
                this.geojsonReservoirs['features'].splice(0, this.geojsonReservoirs['features'].length);
                this.geojsonPipes['features'].splice(0, this.geojsonPipes['features'].length);
                this.geojsonValves['features'].splice(0, this.geojsonValves['features'].length);

                var coordinatesPipes = []

                this.data.junctions.forEach( (value, index, array) => {

                    //id idclient idnode GPS_lat GPS_lng type iddevice demand head pressure elevation date
                            
                    if (value.type == 'Junction') {
                        
                        if (value.iddevice === null) {
                            
                            description =
                                '<div class="content-between m-0 cursor-default text-xs" style="background:rgba(0,42,80,0.85) !important; border-color:#fff">' +
                               '<div class="flex justify-between text-base text-white-snow"><p>' + this.$t("general.Information") + '</p></div>' +
                               '<div class="border-t border-gray-medium mb-1"></div>' +
                                '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Id") + ': &nbsp</p><p class="text-gray-light">' + value.idnode + '</p></div>' +
                                '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Type") + ': &nbsp</p> <p class="text-gray-light">' + this.$t("water.Node") + '</p></div>' +
                                '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Category") + ': &nbsp</p><p class="text-gray-light">' + this.$t("water.Junction") + '</p></div>' +
                                '<div class="flex justify-between text-cyan-text mb-2"><p>' + this.$t("water.Elevation") + ': &nbsp</p><p class="text-gray-light">' + (value.elevation === 0 ?  0: Math.round(value.elevation * 1000)/1000) + ' m</p></div>' +
                                '<div class="flex justify-between text-base text-white-snow"><p>' + this.$t("water.Simulated parameters") + '</p></div>' +
                                '<div class="border-t border-gray-medium mb-1"></div>' +
                                '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Head") + ': &nbsp</p><p class="text-gray-light">' + (value.head === 0 ?  0: Math.round(value.head * 1000)/1000) + ' m</p></div>' +
                                '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Demand") + ': &nbsp</p><p class="text-gray-light">' + (value.demand === 0 ?  0: Math.round(value.demand * 1000)/1000) + ' m³/h</p></div>' +
                                '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Pressure") + ': &nbsp</p><p class="text-gray-light">' + (value.pressure === 0 ?  0: Math.round(value.pressure * 1000)/1000) + ' m.c.a</p></div>' +
                                '</div>';
                        }else{

                            description =
                                '<div class="content-between m-0 cursor-default text-xs" style="background:rgba(0,42,80,0.85) !important; border-color:#fff">' +
                               '<div class="flex justify-between text-base text-white-snow"><p>' + this.$t("general.Information") + '</p></div>' +
                               '<div class="border-t border-gray-medium mb-1"></div>' +
                                '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Id") + ': &nbsp</p><p class="text-gray-light">' + value.idnode + '</p></div>' +
                                '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Type") + ': &nbsp</p> <p class="text-gray-light">' + this.$t("water.Node") + '</p></div>' +
                                '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.IdDevice") + ': &nbsp</p><p class="text-gray-light">' + value.iddevice + '</p></div>' +
                                '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Category") + ': &nbsp</p><p class="text-gray-light">' + this.$t("water.Junction") + '</p></div>' +
                                '<div class="flex justify-between text-cyan-text mb-2"><p>' + this.$t("water.Elevation") + ': &nbsp</p><p class="text-gray-light">' + (value.elevation === 0 ?  0: Math.round(value.elevation * 1000)/1000) + ' m</p></div>' +
                                '<div class="flex justify-between text-base text-white-snow"><p>' + this.$t("water.Simulated parameters") + '</p></div>' +
                                '<div class="border-t border-gray-medium mb-1"></div>' +
                                '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Head") + ': &nbsp</p><p class="text-gray-light">' + (value.head === 0 ?  0: Math.round(value.head * 1000)/1000) + ' m</p></div>' +
                                '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Demand") + ': &nbsp</p><p class="text-gray-light">' + (value.demand === 0 ?  0: Math.round(value.demand * 1000)/1000) + ' m³/h</p></div>' +
                                '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Pressure") + ': &nbsp</p><p class="text-gray-light">' + (value.pressure === 0 ?  0: Math.round(value.pressure * 1000)/1000) + ' m.c.a</p></div>' +
                                '</div>';
                        }

                        this.newFeature = {
                            'type': 'Feature',
                            'properties': {
                                'name': 'Junction_' + value.idnode, 
                                'id': value.idnode,
                                'idDevice': value.iddevice,
                                'type':'Node',
                                'category': value.category,
                                'elevation': (value.elevation === 0 ?  0: Math.round(value.elevation * 1000)/1000),
                                'head': (value.head === 0 ?  0: Math.round(value.head * 1000)/1000),
                                'demand': (value.demand === 0 ?  0: Math.round(value.demand * 1000)/1000),
                                'pressure': (value.pressure === 0 ?  0: Math.round(value.pressure * 1000)/1000) ,
                                'description':description,
                                'detail': description,
                                'insidescreen': "",

                            },
                            'geometry': {
                                'type': 'Point',
                                'coordinates': [value.GPS_lng, value.GPS_lat]
                            }
                        }

                        this.geojsonJunctions['features'].push(this.newFeature)


                    }
                    if (value.type == 'Tank'){
                        description =
                        '<div class="content-between m-0 cursor-default text-xs" style="background:rgba(0,42,80,0.85) !important; border-color:#fff">' +
                           '<div class="flex justify-between text-base text-white-snow"><p>' + this.$t("general.Information") + '</p></div>' +
                           '<div class="border-t border-gray-medium mb-1"></div>' +
                            '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Id") + ': &nbsp</p><p class="text-gray-light">' + value.idnode + '</p></div>' +
                            '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Type") + ': &nbsp</p> <p class="text-gray-light">' + this.$t("water.Node") + '</p></div>' +
                            //'<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.IdDevice") + ': &nbsp</p><p class="text-gray-light">' + value[6] + '</p></div>' +
                            '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Category") + ': &nbsp</p><p class="text-gray-light">' + this.$t("water.Tank") + '</p></div>' +
                            '<div class="flex justify-between text-cyan-text mb-2"><p>' + this.$t("water.Elevation") + ': &nbsp</p><p class="text-gray-light">' + (value.elevation === 0 ?  0: Math.round(value.elevation * 1000)/1000) + ' m</p></div>' +
                            '<div class="flex justify-between text-base text-white-snow"><p>' + this.$t("water.Simulated parameters") + '</p></div>' +
                            '<div class="border-t border-gray-medium mb-1"></div>' +
                            '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Head") + ': &nbsp</p><p class="text-gray-light">' + (value.head === 0 ?  0: Math.round(value.head * 1000)/1000) + ' m</p></div>' +
                            '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Demand") + ': &nbsp</p><p class="text-gray-light">' + (value.demand === 0 ?  0: Math.round(value.demand * 1000)/1000) + ' m³/h</p></div>' +
                            '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Pressure") + ': &nbsp</p><p class="text-gray-light">' + (value.pressure === 0 ?  0: Math.round(value.pressure * 1000)/1000) + ' m.c.a</p></div>' +
                            '</div>';

                        this.newFeature = {
                            'type': 'Feature',
                            'properties': {
                                'name': 'Tank_' + value.idnode,
                                'id': value.idnode,
                                'type':'Node',
                                'category': value.category,
                                'elevation': (value.elevation === 0 ?  0: Math.round(value.elevation * 1000)/1000),
                                'head': (value.head === 0 ?  0: Math.round(value.head * 1000)/1000),
                                'demand': (value.demand === 0 ?  0: Math.round(value.demand * 1000)/1000),
                                'pressure': (value.pressure === 0 ?  0: Math.round(value.pressure * 1000)/1000) ,
                                'description':description,
                                'detail': description,
                                'insidescreen': "",

                            },
                            'geometry': {
                                'type': 'Point',
                                'coordinates': [value.GPS_lng, value.GPS_lat]
                            }
                        }

                        this.geojsonTanks['features'].push(this.newFeature);
                    }
                    if (value.type == 'Reservoir'){
                        description =
                        '<div class="content-between m-0 cursor-default text-xs" style="background:rgba(0,42,80,0.85) !important; border-color:#fff">' +
                           '<div class="flex justify-between text-base text-white-snow"><p>' + this.$t("general.Information") + '</p></div>' +
                           '<div class="border-t border-gray-medium mb-1"></div>' +
                            '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Id") + ': &nbsp</p><p class="text-gray-light">' + value.idnode + '</p></div>' +
                            '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Type") + ': &nbsp</p> <p class="text-gray-light">' + this.$t("water.Node") + '</p></div>' +
                            //'<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.IdDevice") + ': &nbsp</p><p class="text-gray-light">' + value[6] + '</p></div>' +
                            '<div class="flex justify-between text-cyan-text mb-2"><p>' + this.$t("general.Category") + ': &nbsp</p><p class="text-gray-light">' + this.$t("water.Reservoir") + '</p></div>' +
                            //'<div class="flex justify-between text-cyan-text"><p>' + this.$t("water.Elevation") + ': &nbsp</p><p class="text-gray-light">' + (value.elevation === 0 ?  0: Math.round(value.elevation *100000)/100000) + ' m</p></div>' +
                            '<div class="flex justify-between text-base text-white-snow"><p>' + this.$t("water.Simulated parameters") + '</p></div>' +
                            '<div class="border-t border-gray-medium mb-1"></div>' +
                            '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Head") + ': &nbsp</p><p class="text-gray-light">' + (value.head === 0 ?  0: Math.round(value.head * 1000)/1000) + ' m</p></div>' +
                            '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Demand") + ': &nbsp</p><p class="text-gray-light">' + (value.demand === 0 ?  0: Math.round(value.demand * 1000)/1000) + ' m³/h</p></div>' +
                            '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Pressure") + ': &nbsp</p><p class="text-gray-light">' + (value.pressure === 0 ?  0: Math.round(value.pressure * 1000)/1000) + ' m.c.a</p></div>' +
                            '</div>';
                            
                        this.newFeature = {
                            'type': 'Feature',
                            'properties': {
                                'name': 'Reservoir_' + value.idnode,
                                'id': value.idnode,
                                'type':'Node',
                                'category': value.category,
                                //'elevation': (value.elevation === 0 ?  0: Math.round(value.elevation *100000)/100000),
                                'head': (value.head === 0 ?  0: Math.round(value.head * 1000)/1000),
                                'demand': (value.demand === 0 ?  0: Math.round(value.demand * 1000)/1000),
                                'pressure': (value.pressure === 0 ?  0: Math.round(value.pressure * 1000)/1000) ,
                                'description':description,
                                'detail': description,
                                'insidescreen': "",

                            },
                            'geometry': {
                                'type': 'Point',
                                'coordinates': [value.GPS_lng, value.GPS_lat]
                            }
                        }

                        this.geojsonReservoirs['features'].push(this.newFeature);
                    }

                    nodes_coords[value.idnode] = [value.GPS_lng, value.GPS_lat];
            

                })

                this.data.pipes.forEach( (value, index, array) => {

                    //id, idclient, idpipe, start_node_name, end_node_name, length, diameter, roughness, minor_loss, status, headloss, velocity, date

                    let checked = []
                    if (value.status == 1) {
                        checked = ['checked', 'Open',this.$t("water.Open")]
                    } else {
                        checked = ['', 'Closed',this.$t("water.Closed")]
                    }
                    
                    description =
                        '<div class="content-between m-0 cursor-default text-xs" style="background:rgba(0,42,80,0.85) !important; border-color:#fff">' +
                        '<div class="flex justify-between text-base text-white-snow"><p>' + this.$t("general.Information") + '</p></div>' +
                        '<div class="border-t border-gray-medium mb-1"></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Id") + ': &nbsp</p><p class="text-gray-light">' + value.idpipe + '</p></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Type") + ' &nbsp</p><p class="text-gray-light">' + this.$t("water.Link") + '</p></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Category") + ': &nbsp</p><p class="text-gray-light">'+ this.$t("water.Pipe") + '</p></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("water.StartNode") + ': &nbsp</p><p class="text-gray-light">' + value.start_node_name + '</p></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("water.EndNode") + ': &nbsp</p><p class="text-gray-light">' + value.end_node_name + '</p></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("water.Length") + ': &nbsp</p><p class="text-gray-light">' + (value.length === 0 ?  0: Math.round(value.length * 1000)/1000) + ' m</p></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("water.Diameter") + ': &nbsp</p><p class="text-gray-light">' + (value.diameter === 0 ?  0: Math.round(value.diameter * 1000)/1000) + ' m</p></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("water.Roughness") + ': &nbsp</p><p class="text-gray-light">' +  (value.roughness === 0 ?  0: Math.round(value.roughness * 1000)/1000) + '</p></div>' +
                        '<div class="flex justify-between text-cyan-text mb-2"><p>' + this.$t("water.MinorLoss") + ': &nbsp</p><p class="text-gray-light">' +  (value.minor_loss === 0 ?  0: Math.round(value.minor_loss * 1000)/1000) + '</p></div>' +
                        
                        '<div class="flex justify-between text-base text-white-snow"><p>' + this.$t("water.Simulated parameters") + '</p></div>' +
                        '<div class="border-t border-gray-medium mb-1"></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("water.Status") + ': &nbsp</p><p class="text-gray-light">' + checked[2] + '</p></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("water.Headloss") + ': &nbsp</p><p class="text-gray-light">' + (value.headloss === 0 ?  0: Math.round(value.headloss * 1000)/1000) + '</p></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("water.Velocity") + ': &nbsp</p><p class="text-gray-light">' + (value.velocity === 0 ?  0: Math.round(value.velocity * 1000)/1000) + ' m/s</p></div>' +
                        //'<div class="flex justify-between text-cyan-text"><p>Reaction rate: &nbsp</p><p class="text-gray-light">' + Math.round(value[12]*100)/100 +'</p></div>'+
                        '</div>';

                    this.newFeature = {
                        'type': 'Feature',
                        'properties': {
                            'name': 'Pipe_' + value.idpipe,
                            'id': value.idpipe,
                            'type':'Link',
                            'category': 'Pipe',
                            'start_node': value.start_node_name,
                            'end_node': value.end_node_name,
                            'lenght': (value.length === 0 ?  0: Math.round(value.length * 1000)/1000),
                            'diameter': (value.diameter === 0 ?  0: Math.round(value.diameter * 1000)/1000),
                            'roughness': (value.roughness === 0 ?  0: Math.round(value.roughness * 1000)/1000),
                            'minorLoss': (value.minor_loss === 0 ?  0: Math.round(value.minor_loss * 1000)/1000),
                            'status':  checked[1],
                            'headloss': (value.headloss === 0 ?  0: Math.round(value.headloss * 1000)/1000),
                            'velocity': (value.velocity === 0 ?  0: Math.round(value.velocity * 1000)/1000),
                            'description':description,
                            'options': description,
                            'insidescreen': "",

                        },
                        'geometry': {
                            'type': 'LineString',
                            'coordinates': [[nodes_coords[value.start_node_name][0], nodes_coords[value.start_node_name][1]], [nodes_coords[value.end_node_name][0], nodes_coords[value.end_node_name][1]]]
                        }
                    }

                    coordinatesPipes.push([[nodes_coords[value.start_node_name][0], nodes_coords[value.start_node_name][1]], [nodes_coords[value.end_node_name][0], nodes_coords[value.end_node_name][1]]])
                    this.geojsonPipes['features'].push(this.newFeature)

                })

                this.data.valves.forEach( (value, index, array) => {

                    //id, idclient, idvalve, start_node_name, end_node_name, diameter, setting, minor_loss, status, headloss, velocity, date

                    let checked = []
                    if (value.status ==1 || value.status ==2){
                        checked = ['checked', 'Open',this.$t("water.Open")]
                    } else {
                        checked = ['', 'Closed',this.$t("water.Closed")]
                    }

                    description =
                        '<div class="content-between m-0 cursor-default text-xs" style="background:rgba(0,42,80,0.85) !important; border-color:#fff">' +
                       '<div class="flex justify-between text-base text-white-snow"><p>' + this.$t("general.Information") + '</p></div>' +
                       '<div class="border-t border-gray-medium mb-1"></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Id") + ': &nbsp</p><p class="text-gray-light">' + value.idvalve + '</p></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Type") + ' &nbsp</p><p class="text-gray-light">' + this.$t("water.Link") + '</p></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("general.Category") + ': &nbsp</p><p class="text-gray-light">Valve</p></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("water.StartNode") + ': &nbsp</p><p class="text-gray-light">' + value.start_node_name + '</p></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("water.EndNode") + ': &nbsp</p><p class="text-gray-light">' + value.end_node_name + '</p></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("water.Diameter") + ': &nbsp</p><p class="text-gray-light">' + (value.diameter === 0 ?  0: Math.round(value.diameter * 1000)/1000) + ' m</p></div>' +
                        '<div class="flex justify-between text-cyan-text mb-2"><p>' + this.$t("water.Setting") + ': &nbsp</p><p class="text-gray-light">' + (value.setting === 0 ?  0: Math.round(value.setting * 1000)/1000) + '</p></div>' +
                        //'<div class="flex justify-between text-cyan-text"><p>Roughness: &nbsp</p><p class="text-gray-light"' + value.roughness +'</p></div>'+
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("water.MinorLoss") + ': &nbsp</p><p class="text-gray-light">' +  (value.minor_loss === 0 ?  0: Math.round(value.minor_loss * 1000)/1000) + '</p></div>' +
                        '<div class="flex justify-between text-base text-white-snow"><p>' + this.$t("water.Simulated parameters") + '</p></div>' +
                        '<div class="border-t border-gray-medium mb-1"></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("water.Status") + ': &nbsp</p><p class="text-gray-light">' + checked[2] + '</p></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("water.Headloss") + ': &nbsp</p><p class="text-gray-light">' +  (value.headloss === 0 ?  0: Math.round(value.headloss * 1000)/1000) + '</p></div>' +
                        '<div class="flex justify-between text-cyan-text"><p>' + this.$t("water.Velocity") + ': &nbsp</p><p class="text-gray-light">' + (value.velocity === 0 ?  0: Math.round(value.velocity * 1000)/1000) + ' m/s</p></div>' +
                        '</div>';

                    this.newFeature = {
                        'type': 'Feature',
                        'properties': {
                            'name': 'Valve_' + value.idvalve,
                            'id': value.idvalve,
                            'type':'Link',
                            'category': 'Valve',
                            'start_node': value.start_node_name,
                            'end_node': value.end_node_name,
                            'diameter': (value.diameter === 0 ?  0: Math.round(value.diameter  * 1000)/1000),
                            'setting': (value.setting === 0 ?  0: Math.round(value.setting * 1000)/1000),
                            'minor_Loss': (value.minor_loss === 0 ?  0: Math.round(value.minor_loss * 1000)/1000),
                            'status':  checked[1],
                            'headloss': (value.headloss === 0 ?  0: Math.round(value.headloss * 1000)/1000),
                            'velocity': (value.velocity === 0 ?  0: Math.round(value.velocity * 1000)/1000),
                            'description':description,
                            'options': description,
                            'insidescreen': "",

                        },
                        'geometry': {
                            'type': 'LineString',
                            'coordinates': [[nodes_coords[value.start_node_name][0], nodes_coords[value.start_node_name][1]], [nodes_coords[value.end_node_name][0], nodes_coords[value.end_node_name][1]]]
                        }
                    }


                    this.geojsonValves['features'].push(this.newFeature)
                })

                this.generalGeoJson.features = this.generalGeoJson.features.concat(this.geojsonJunctions)
                this.generalGeoJson.features = this.generalGeoJson.features.concat(this.geojsonTanks)
                this.generalGeoJson.features = this.generalGeoJson.features.concat(this.geojsonReservoirs)
                this.generalGeoJson.features = this.generalGeoJson.features.concat(this.geojsonPipes)
                this.generalGeoJson.features = this.generalGeoJson.features.concat(this.geojsonValves)
                
            },

            changeStatusNetworkElement(idnode, status, element, map) {

                /*return axios
                .get('/api/epanet/simulation_modifying_network/'+ idnode + '/' + status + '/' + window.time)
                .then(response =>{
                return [response.data];
                })
                .catch(function(error) {
                return ("Failed!", error);
                })  
                
                ;  */
                return axios(
                    {
                        method: 'get',
                        url: window.location.origin + '/api/epanet/simulation_modifying_network/' + idnode + '/' + status + '/' + element + '/' + window.time,
                        headers: {
                            'Accept': 'application/json',
                            'Content-Type': 'application/json',
                            'Authorization': 'Bearer ' + this.user.token
                        },
                    })
                    .then((response) => {
                        if (parseInt(response.data) != null && response.data != ""){

                            // window.Papa.parse('simulations/data_time.csv', {
                            //             download: true,
                            //             complete: function(results) {
                            //                 var dataUpdated = results.data
                            //                 ////console.log(dataUpdated)
                            //                 dataUpdated.shift()
                            //                 window.junctions.forEach( function(value, index, array) {
                            //                     window.junctions[index][5]=dataUpdated[index][2] //demand
                            //                     window.junctions[index][6]=dataUpdated[index][3] //head
                            //                     window.junctions[index][7]=dataUpdated[index][4] //pressure

                            //                 })
                            //                 updateLayers()
                            //                 window.emitter.emit('changeLoaderStatus', false, 'orbit') //Start loadder
                            //             }
                            // }) 
                            var dataUpdated = response.data
                            //dataUpdated[0] ->junctions
                            //dataUpdated[1] ->pipes
                            //dataUpdated[2] ->valves

                            this.data.junctions.forEach(function (junction, index, array){

                                // var dataUpdated = results.data
                                // console.log(dataUpdated)
                                // dataUpdated.shift()
                                //idnode lat lng  type head demand pressure elevation
                                //id idclient idnode lat long type iddevice demand head pressure elevation date_cration date_update

                                junction.demand = (dataUpdated[0][index]['demand']).toString() //demand
                                junction.head = (dataUpdated[0][index]['head']).toString() //head
                                junction.pressure = (dataUpdated[0][index]['pressure']).toString() //pressure


                            })

                            this.data.pipes.forEach(function (pipe, index, array){

                                // var dataUpdated = results.data
                                // console.log(dataUpdated)
                                // dataUpdated.shift()
                                //idnode lat lng  type head demand pressure elevation
                                //id, idclient, idpipe, start_node_name, end_node_name, length, diameter, roughness, minor_loss, status, headloss, velocity, reaction_rate, date_creation, date_update
                                pipe.status = (dataUpdated[1][index]['status']).toString() == 1 ? "Open" : (dataUpdated[1][index]['status']).toString() == 2 ? "Closed" : "Active";

                                //pipe[9]=(dataUpdated[1][index]['status']).toString() //status
                                pipe.headloss = (dataUpdated[1][index]['headloss']).toString() //headloss
                                pipe.velocity = (dataUpdated[1][index]['velocity']).toString() //velocity
                                //pipe[12] = "555.666"//(dataUpdated[1][index]['reaction_rate']).toString() //reaction_rate


                            })

                            this.data.valves.forEach(function (valve, index, array){

                                // var dataUpdated = results.data
                                // dataUpdated.shift()
                                //idnode lat lng  type head demand pressure elevation
                                //id, idclient, idvalve, start_node_name, end_node_name, diameter, setting, minor_loss, status, headloss, velocity, date_creation, date_update

                                valve.status = (dataUpdated[2][index]['status']).toString() == "1" ? "Open" : "Closed";
                                //valve[8]=(dataUpdated[2][index]['headloss']).toString() //status
                                valve.headloss = (dataUpdated[2][index]['headloss']).toString() //headloss
                                valve.velocity = (dataUpdated[2][index]['velocity']).toString() //velocity


                            })

                            this.updateLayers(map);
                            window.emitter.emit('changeLoaderStatus', false, 'orbit') //Start loadder
                        } else {
                            window.emitter.emit('changeLoaderStatus', false, 'orbit') //Start loadder
                        }
                        //simulation = JSON.parse(response)
                        //console.log(JSON.parse(response))
                    })
                    .catch( (error) => {
                        return ("Failed!", error);
                    });

            },

            updateLayers( map){
                this.createGeoJsons()
                map.removeLayer('junctions')
                map.removeSource('junctions')
                map.removeLayer('tanks')
                map.removeSource('tanks')
                map.removeLayer('reservoirs')
                map.removeSource('reservoirs')
                map.removeLayer('pipes')
                map.removeSource('pipes')
                map.removeLayer('valves')
                map.removeSource('valves')

                map.addSource('junctions', {
                    'type': 'geojson',
                    'data': this.geojsonJunctions
                })
                map.addLayer({
                    'id': 'junctions',
                    'type': 'circle',
                    'source': 'junctions',
                    'layout': {
                        'visibility': 'visible'
                    },
                    'paint': {
                        'circle-radius': 6,
                        'circle-color': '#7569fb',
                        "circle-stroke-width": 1,
                        "circle-stroke-color": '#fff'
                    }
                })

                map.addSource('tanks', {
                    'type': 'geojson',
                    'data': this.geojsonTanks
                })
                map.addLayer({
                    'id': 'tanks',
                    'type': 'circle',
                    'source': 'tanks',
                    'layout': {
                        'visibility': 'visible'
                    },
                    'paint': {
                        'circle-radius': 6,
                        'circle-color': '#268678',
                        "circle-stroke-width": 1,
                        "circle-stroke-color": '#fff'
                    }
                })

                map.addSource('reservoirs', {
                    'type': 'geojson',
                    'data': this.geojsonReservoirs
                })
                map.addLayer({
                    'id': 'reservoirs',
                    'type': 'circle',
                    'source': 'reservoirs',
                    'layout': {
                        'visibility': 'visible'
                    },
                    'paint': {
                        'circle-radius': 6,
                        'circle-color': '#96be6e',
                        "circle-stroke-width": 1,
                        "circle-stroke-color": '#fff'
                    }
                })

                map.addSource('pipes', {
                    'type': 'geojson',
                    'data': this.geojsonPipes
                })
                map.addLayer({
                    'id': 'pipes',
                    'type': 'line',
                    'source': 'pipes',
                    'layout': {
                        'line-join': 'round',
                        'line-cap': 'round',
                        'visibility': 'visible'
                    },
                    'paint': {
                        'line-color': '#3D51E2',
                        'line-width': 3,
                    }
                })

                map.addSource('valves', {
                    'type': 'geojson',
                    'data': this.geojsonValves
                });
                map.addLayer({
                    'id': 'valves',
                    'type': 'line',
                    'source': 'valves',
                    'layout': {
                        'line-join': 'round',
                        'line-cap': 'round',
                        'visibility': 'visible'
                    },
                    'paint': {
                        'line-color': '#5b2293',
                        'line-width': 3,
                    }
                });
            },

            animatePipes(map) {

                var startPoint = []
                var endPoint = []
                var velocities = []
                //var longitudes = []
                for (let i = 0; i < this.geojsonPipes.features.length; i++) {
                    var feature = this.geojsonPipes.features[i];

                    var startCordinates0 = parseFloat(feature.geometry.coordinates[0][0])
                    var startCordinates1 = parseFloat(feature.geometry.coordinates[0][1])
                    var startCordinates = [startCordinates0, startCordinates1]

                    var endCordinates0 = parseFloat(feature.geometry.coordinates[1][0])
                    var endCordinates1 = parseFloat(feature.geometry.coordinates[1][1])
                    var endCordinates = [endCordinates0, endCordinates1]

                    velocities.push(feature.properties.velocity)
                    startPoint.push(startCordinates)
                    endPoint.push(endCordinates)
                    //longitudes.push(parseFloat(feature.properties.lenght))
                }
                
                var sum = 0;
                for(let i = 0; i <= velocities.length-1; i ++){
                    sum += velocities[i];
                }

                const avg = sum / velocities.length;

                var adjustFactor = avg / 0.0009;

                var lineCoordinates = [];
                var animationCounter = []

                for (let i = 0; i < startPoint.length; i++) {
                    var speedFactor = velocities[i]     // speedFactor/adjustFactor -> número de trozos por longitud de grado 
                    if (speedFactor != 0) {

                        var diffX = endPoint[i][0] - startPoint[i][0];
                        var diffY = endPoint[i][1] - startPoint[i][1];

                        var sfX = (diffX * speedFactor)/adjustFactor;
                        var sfY = (diffY * speedFactor)/adjustFactor;
                        
                        var x = 0;
                        var j = 0;

                        lineCoordinates[i] = []
                        while (Math.abs(x) < Math.abs(diffX) || Math.abs(j) < Math.abs(diffY)) {

                            lineCoordinates[i].push([startPoint[i][0] + x, startPoint[i][1] + j]);

                            if (Math.abs(x) < Math.abs(diffX)) {
                                x += sfX;
                            }

                            if (Math.abs(j) < Math.abs(diffY)) {
                                j += sfY;

                            }
                        }

                        lineCoordinates[i].push([endPoint[i][0], endPoint[i][1]]);
                        animationCounter.push([0, lineCoordinates[i].length - 1])

                    } else {

                        animationCounter.push("No velocity")
                    }
                }

                let geojson = this.geojson;
                

                function animateLine() {
                    for (let i = 0; i < lineCoordinates.length; i++) {

                        if (velocities[i] != 0) {

                            if (animationCounter[i][0] <= animationCounter[i][1]) {

                                if (animationCounter[i][0] === 0 || animationCounter[i][0] === 1) {

                                    geojson.features[i].geometry.coordinates.push(lineCoordinates[i][animationCounter[i][0]]);
                                } else {
                                    // if(animationCounter[i][0] > 50){
                                    //     animationCounter[i][0] === 0 ? geojson.features[i].geometry.coordinates[0] = lineCoordinates[i][animationCounter[i][0]] : geojson.features[i].geometry.coordinates[0] = geojson.features[i].geometry.coordinates[0] +1;
                                    //    // geojson.features[i].geometry.coordinates[0] = lineCoordinates[i][animationCounter[i][0]]

                                    // }
                                    geojson.features[i].geometry.coordinates[1] = lineCoordinates[i][animationCounter[i][0]]
                                }

                                animationCounter[i][0] += 1
                            } else {

                                animationCounter[i][0] = 0
                                geojson.features[i].geometry.coordinates.splice(0, 2);
                            }
                        }
                    }
                    //console.log(geojson.features[0].geometry.coordinates)
                    map.getSource('pipes-animation').setData(geojson);
                    requestAnimationFrame(animateLine);
                }

                animateLine();
            },

            MapFitBounds(timeout, map, bounds) {
                setTimeout(() => {
                    //bounds = new mapboxgl.LngLatBounds();
                    this.generalGeoJson.features.forEach((element, index) => {

                        if(this.generalGeoJson.features[index].features){
                            this.generalGeoJson.features[index].features.forEach((feature) => {
                                bounds.extend(feature.geometry.coordinates);
                            });
                        }
                    });

                    map.fitBounds(
                        bounds,
                        { padding: { top: 50, bottom: 50, left: 50, right: 50 } },
                        { duration: 0 }
                    );
                }, timeout);
            },

            isOnScreen(map) {

                if (document.getElementById("device_list"))
                    document.getElementById("device_list").innerHTML = "";

                    this.generalGeoJson.features.forEach((element, index) => {

                      if(this.generalGeoJson.features[index].features){
                        this.generalGeoJson.features[index].features.forEach((feature) => {
                            if (
                                map.getBounds()._sw.lng <= feature.geometry.coordinates[0] &&
                                feature.geometry.coordinates[0] <= map.getBounds()._ne.lng &&
                                map.getBounds()._sw.lat <= feature.geometry.coordinates[1] &&
                                feature.geometry.coordinates[1] <= map.getBounds()._ne.lat
                                ){
                                    feature.properties.insidescreen = true;
                                } else {
                                    feature.properties.insidescreen = false;
                                }
                        });

                        for (
                            var marker = 0;
                            marker < this.generalGeoJson.features[index].features.length;
                            marker++
                        ) {
                            document.getElementById("device_list").innerHTML +=
                                `<li><a class='device_list_item cursor-pointer' id="list_device_` +
                                this.generalGeoJson.features[index].features[marker].properties.category +
                                `_` +
                                marker +
                                `">` +
                                this.generalGeoJson.features[index].features[marker].properties.name +
                                `</a></li>`;
                        }
                    }
                });
            },

            searchfilter() {
                let i = 0;
                
                this.generalGeoJson.features.forEach((element, index) => {

                    var input,
                    filter,
                    ul,
                    li,
                    IdDevice,
                    id,
                    name,
                    textId,
                    txtValueName,
                    geojsonobj = this.generalGeoJson.features[index];


                    //text input
                    input = document.getElementById("searchbar");

                    //text to filter
                    filter = input.value.toUpperCase();

                    ul = document.getElementById("device_list");
                    li = ul.getElementsByTagName("li");


                    if(geojsonobj.features){
                        geojsonobj.features.forEach((feature) => {
                            // id search
                            id = feature.properties.id;
                            //textId = id.toString();

                            name = feature.properties.name;
                            txtValueName = name.toString();

                            if(feature.properties.idDevice){
                                IdDevice = feature.properties.idDevice;
                                //txtIdDevice = IdDevice.toString();
                            }
    
                            if (filter != "") {

                                if (
                                    txtValueName.toUpperCase().indexOf(filter) > -1 ||
                                    filter == "ALL" ||
                                    id.indexOf(filter) > -1 ||
                                    (!IdDevice || IdDevice.toUpperCase().indexOf(filter) > -1) 
                                ) {
                                    li[i].style.display = "";
                                } else {
                                    li[i].style.display = "none";
                                }
                            } else {
                                if (feature.properties.insidescreen == true && this.showlist) {
                                    li[i].style.display = "";
                                } else {
                                    li[i].style.display = "none";
                                }
                            }

                            i++;
                        });
                    }
                });
            },
        },
    }
</script>
